#!/usr/bin/python
# -*- coding: utf-8 -*-

import matplotlib.pyplot as plt
import numpy as np
import scipy.io.wavfile as wavf
from numpy import binary_repr

alphabet=" ABCDEFGHIJKLMNOPQRSTUVWXYZ'!,?." #alphabet très simple, que des majuscules et un espace

st="LA PHYSIQUE C'EST FANTASTIQUE! "  #C'est le message à transmettre, il ne doit contenir que les charactères de l'alphabet ci dessus

Fe = 44100;  # Freq échantillonnage
Te = 1.0/Fe; # Période d'échantillonnage
N=1000			#durée d'un bit (en nbr de points)
n=(len(st)*5+6)	#Nbr de bits car chaque lettre sera convertie en un code binaire sur 5 bits, ex: A, numéro 1, devient 00001; B, numéro 2, devient 00010
duree=n*N/Fe #durée totale du message en secondes, +6 car ensuite on rajoute un préambule 1010 et une fin 01
print('duree=',duree)
print('n=',n)
message='1010'    # c'est là où on rajoute le préambule

for i in range(0,len(st)):										# boucle qui génère le message binaire
	message+=str(binary_repr(alphabet.index(st[i]), width=5))			# binary_repr() est la fonction qui convertit l'index de la lettre en binaire sur 5 chiffres
message=message+'01'		# on rajoute 01 à la fin

print(message)

taux=0.15

modulant=[]
for m in range(0,len(message)):			# le signal modulant, c'est l'enveloppe du signal, signal
	for j in range(m*N,(m+1)*N):
		modulant.append(float(message[m])+taux)	# taux c'est le taux de modulation: 1 si 1 et 0.15 si 0

f = 1000;   # fréquence du signal de la porteuse

t = np.arange(len(modulant)) 
print('t=',len(modulant))
sin = np.sin(2*np.pi*f*t/Fe) #on génère une sinusoide de frequence f

sin=sin[:len(modulant)]		#pour être sûr que modulant et sin ont le même nbr de points (sinon erreur lors de la multiplication)
print('sin=',len(sin))
mod=modulant*sin		#on génère le signal modulé en multipliant les deux

t=t[:len(modulant)]
print('t=',len(t))
print('len mod=',len(mod))
plt.plot(t,mod)
plt.ylim(-2,2)

xn = np.array(mod) #mise en forme et export au format wav
wavf.write('export.wav', Fe, xn)

plt.show() #affichage des graphes

